local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");

--Set stage buttons to on/off depending on metrics
if tostring(NOTESKIN:GetMetric("NoteskinPreferences","StageButtonToggle")) == "off" then
	stageButtonActive = 0
else
	stageButtonActive = 1
end

local t = Def.ActorFrame{

--Notefield laser graphic
	Def.Sprite {
		Texture="Lasers/" .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","LaserColor"));
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			if Reverse then
				self:blend("BlendMode_Add")
				self:addy(-4.5)
				self:zoom(0.44444444)
				self:valign(1)
				self:diffusealpha(0)
			else
				self:blend("BlendMode_Add")
				self:addy(4.5)
				self:zoom(0.44444444)
				self:valign(1)
				self:diffusealpha(0)
				self:addrotationz(180)
			end
		end,
		PressCommand=function(self)
			self:stoptweening()
			self:accelerate(.05)
			self:diffusealpha(.8)
		end,
		LiftCommand=function(self)
			self:stoptweening()
			self:linear(.1)
			self:diffusealpha(0)
		end,
		NoneCommand=function(self)
		end
	};

--Receptor button idle
	Def.Sprite {
		Texture="Stage/2 button";
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			if Reverse then
				self:zoom(0.44444444)
				self:diffusealpha(stageButtonActive)
				self:addy(31)
			else
				self:zoom(0.44444444)
				self:diffusealpha(stageButtonActive)
				self:addy(-31)
				self:addrotationz(180)
			end
		end,
		PressCommand=function(self)
			self:diffusealpha(0)
			self:diffusealpha(0)
		end,
		LiftCommand=function(self)
			self:stoptweening()
			self:sleep(.032)
			self:diffusealpha(stageButtonActive)
		end,
		NoneCommand=function(self)
			self:diffusealpha(stageButtonActive)
		end
	};

--Receptor button pressed
	Def.Sprite {
		Texture="Stage/2 down button";
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			if Reverse then
				self:zoom(0.44444444)
				self:diffusealpha(0)
				self:addy(31)
			else
				self:zoom(0.44444444)
				self:diffusealpha(0)
				self:addy(-31)
				self:addrotationz(180)
			end
		end,
		PressCommand=function(self)
			self:stoptweening()
			self:diffusealpha(stageButtonActive)
		end,
		LiftCommand=function(self)
			self:stoptweening()
			self:sleep(.032)
			self:diffusealpha(0)
		end,
		NoneCommand=function(self)
			self:diffusealpha(0)
		end
	};

};

return t;