--Oregairu v1.4 (4k)
--07/12/2020
--Noteskin based on "retrobar-razor_Max" made by ecafree2. The original can be found at www.youtube.com/ecafree2
--Big big shoutout to poco0317, ecafree2, and Jousway for being my main sources of information about noteskins
--This project would never have taken off without them

--Oregairu illustrations by star741 on Pixiv https://www.pixiv.net/en/users/5851220 (NSFW WARNING: Pixiv has 18+ content)


--This noteskin is customisable, check metrics.ini


--Most of the magic in this noteskin happens in "1 receptor.lua"
--Check that file if you want to know how it works. Comments explain things throughout


local Noteskin = ... or {};
local button = Var "Button"

--Column redirs. The way these work in this noteskin means EVERYTHING BUT 4K IS NOT SUPPORTED
Noteskin.ButtonRedirs = {
	--Dance(4k)
	Left		= "1";
	Down		= "2";
	Up			= "3";
	Right		= "4";
};

--Element redirects
Noteskin.ElementRedirs = {
	--Redirect dim explosion
	["Tap Explosion Dim"] = "Tap Explosion Bright";

	--Redirect mine explosion to tap explosion
	["HitMine Explosion"] = "Tap Explosion Bright";
	
	--Instead of separate hold heads and tails, use the tap note graphics.
	["Hold Head Active"] 	= "Tap Note";
	["Hold Head Inactive"] 	= "Tap Note";
	["Roll Head Active"] 	= "Roll Note";
	["Roll Head Inactive"] 	= "Roll Note";
	["Hold Tail Active"] 	= "Tap Note";
	["Hold Tail Inactive"] 	= "Tap Note";

	--Redirect hold elements
	["Hold Body Inactive"]		= "Hold Body Active";
	--BottomCaps omitted because the redirects don't work for some reason
--[[["Hold BottomCap active"]	= "Hold Body";
	["Hold BottomCap inactive"]	= "Hold Body";--]]
	["Hold TopCap Active"]		= "Hold Body";
	["Hold TopCap Inactive"]	= "Hold Body";

	--Redirect roll elements
	["Roll Body Active"]		= "Roll Body";
	["Roll Body Inactive"]		= "Roll Body";
--[[["Roll BottomCap active"]	= "Roll Body";
	["Roll BottomCap inactive"]	= "Roll Body";--]]
	["Roll TopCap Active"]		= "Roll Body";
	["Roll TopCap Inactive"]	= "Roll Body";
	["Roll Tail Active"] 		= "Roll Note";
	["Roll Tail Inactive"] 		= "Roll Note";
	["Roll Explosion"]			= "Hold Explosion";

	--Redirect mines
	["Tap Mine"]				= "Mine Dot";
};

--Invisible elements
Noteskin.Hide = {
	["Tap Fake"] 				= true;
	["Tap Lift"] 				= true;
};

--Rotations
Noteskin.BaseRotX = {
	Left	= 0;
	UpLeft	= 0;
	Up		= 0;
	Down	= 0;
	UpRight	= 0;
	Right	= 0;
};
Noteskin.BaseRotY = {
	Left	= 0;
	UpLeft	= 0;
	Up		= 0;
	Down	= 0;
	UpRight	= 0;
	Right	= 0;
};

--This part loads elements but I honestly have no clue how it works
local function NoteskinLoader()
	local Button = Var "Button"
	local Element = Var "Element"

	if Noteskin.Hide[Element] then
		--Return a blank element. If SpriteOnly is set, we need to return a
		--sprite; otherwise just return a dummy actor.
		local t;
		if Var "SpriteOnly" then
			t = LoadActor( "_blank" );
		else
			t = Def.Actor {};
		end
		return t .. {
			InitCommand = function(self)
    			self:visible(false)
  			end
		};
	end;


	--Load element and button, using redirs
	local LoadElement = Noteskin.ElementRedirs[Element]
	if not LoadElement then
		LoadElement = Element;
	end;

	local LoadButton = Noteskin.ButtonRedirs[Button]
	if not LoadButton then
		LoadButton = Button;
	end;

	--Get path to thing
	local sPath = NOTESKIN:GetPath( LoadButton, LoadElement );

	--Make actor
	local t = LoadActor( sPath );

	--Apply rotation
	t.BaseRotationX=Noteskin.BaseRotX[sButton]
	t.BaseRotationY=Noteskin.BaseRotY[sButton]

	return t;
end

Noteskin.Load = NoteskinLoader;
Noteskin.CommonLoad = NoteskinLoader;
return Noteskin;