local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");
local bombScaleY

--This check basically makes sure the hold explosion is either "off" or "1"
--At first I had it work the same way as tap explosions but "2" looks horrible for holds
local holdToggle
if tostring(NOTESKIN:GetMetric("NoteskinPreferences","HoldExplosionToggle")) == "off" then
	holdToggle = "off"
else
	holdToggle = "1"
end

local rawMini = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Mini()
--Variable that scales back to 1 according to mini%. Works for both zoom and for some but not all coordinates
--Thanks to ecafree2 for this equation
local miniAdjustedScale = 1/(1-(rawMini/2))

--Grab tap explosion scale from metrics
local playerBombScale = tonumber(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosionScale"))

--Vertically flip explosion if upscroll
if Reverse then
	bombScaleY = miniAdjustedScale
else
	bombScaleY = miniAdjustedScale * -1
end

local t = Def.ActorFrame{
	Def.Sprite {
		Name="Hold Bomb";
		--In readable terms, the path is "Bombs/type color"
		--For holds, the type is forced to 1 or off
		Texture="Bombs/" .. tostring(holdToggle) .. " " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosionColor"));
		Frames=Sprite.LinearFrames(8,0.128);
		InitCommand=function(self)
			self:blend("BlendMode_Add")
			self:diffusealpha(0)
			self:zoom(miniAdjustedScale * playerBombScale)
			self:zoomy(bombScaleY * playerBombScale)
		end,
		HoldingOnCommand=function(self)
			self:stoptweening()
			self:setstate(0)
			self:diffusealpha(1)
		end,
		HoldingOffCommand=function(self)
			self:stoptweening()
			self:diffusealpha(0)
		end,
		RollOnCommand=function(self)
			self:stoptweening()
			self:setstate(0)
			self:diffusealpha(1)
		end,
		RollOffCommand=function(self)
			self:stoptweening()
			self:diffusealpha(0)
		end
	};


};

return t;