local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");
local bombScaleY

--This check basically makes sure the hold explosion is either "off" or "1"
--At first I had it work the same way as tap explosions but "2" looks horrible for holds
local holdToggle
if tostring(NOTESKIN:GetMetric("NoteskinPreferences","HoldExplosionToggle")) == "off" then
	holdToggle = "off"
else
	holdToggle = "1"
end

local rawMini = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions():Mini()
--Variable that scales back to 1 according to mini%. Works for both zoom and for some but not all coordinates
--Thanks to ecafree2 for this equation
local miniAdjustedScale = 1/(1-(rawMini/2))

--Grab tap explosion scale from metrics
local playerBombScale = tonumber(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosionScale"))

--Vertically flip explosion if upscroll
if Reverse then
	bombScaleY = miniAdjustedScale
else
	bombScaleY = miniAdjustedScale * -1
end

local t = Def.ActorFrame{
	Def.Sprite {
		Name="Tap Bomb";
		--In readable terms, the path is "Bombs/type color"
		Texture="Bombs/" .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosion")) .. " " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosionColor"));
		Frames=Sprite.LinearFrames(16,0.256);
		InitCommand=function(self)
			self:zoom(miniAdjustedScale * playerBombScale)
			self:diffusealpha(0)
			self:blend("BlendMode_Add")
			self:zoomy(bombScaleY * playerBombScale)
		end,
		--Custom command for merging most tap explosion commands
		BombCommand=function(self)
			--Diffusing to white resets to original texture colour
			self:stoptweening()
			self:diffuse(color("#FFFFFF"))
			self:setstate(0)
			self:diffusealpha(1)
			self:sleep(0.255):diffusealpha(0)
		end,
		HitMineCommand=function(self)
			--Set colour to red on mine hit
			self:stoptweening()
			self:diffuse(color("#D12A31"))
			self:setstate(0)
			self:diffusealpha(1)
			self:sleep(0.255)
			self:diffusealpha(0)
		end,
		W5Command=function(self)
		--Redirect to "BombCommand"
			self:queuecommand("Bomb")
		end,
		W4Command=function(self)
			self:queuecommand("Bomb")
		end,
		W3Command=function(self)
			self:queuecommand("Bomb")
		end,
		W2Command=function(self)
			self:queuecommand("Bomb")
		end,
		W1Command=function(self)
			self:queuecommand("Bomb")
		end,
		HeldCommand=function(self)
			self:queuecommand("Bomb")
		end
	};

};

return t;